{*************************************************************************}
{*                                                                       *}
{*                  III Olimpiada Informatyczna                          *}
{*                                                                       *}
{*   Rozwiazanie zadania: GONCY                                          *}
{*   Plik:                GON.PAS                                        *}
{*   Autor:               Krzysztof Diks                                              *}
{*************************************************************************}

{$M 10000,0,655360}
program Goncy;
 const MaksN=500; {Maksymalna liczba miast w Bajtocji.}
 type
  ElListySasWsk  =^ElListySas;
  ElListySas     =record
                   Miasto:1..MaksN;
                   Nast  :ElListySasWsk
                  end;
  ListySasiedztwa=array[1..MaksN] of ElListySasWsk;
   {Definicje typow umozliwiajacych zapamietanie bezpiecznego planu.}
  ElPlanuWsk     =^ElPlanu;
  ElPlanu        =record
                   Miasto    :integer;
                   Nast,Poprz:ElPlanuWsk
                  end;
 var
  L         :ListySasiedztwa; {Listy sasiadow miast w Bajtocji.}
  n         :integer;         {Liczba miast w Bajtocji.}
  bPocz,bOst:ElPlanuWsk;      {Wskazniki do pierwszego i ostaniego elementu
                               listy, w ktorej jest pamietany bezpieczny plan.}

 procedure Inicjalizacja;
  var
   i,d:Integer;
   v,w:ElListySasWsk;
   f  :text;
 begin
   {Wczytanie danych wejsciowych i utworzenie list sasiedztwa.}
  assign(f,'GON.IN');  reset(f);
  readln(f,n);
  for i:=1 to n do L[i]:=nil;
  readln(f,d);
  for i:=1 to d do begin
   new(v);  new(w);
   readln(f,v^.Miasto,w^.Miasto);
   w^.Nast:=L[v^.Miasto];  L[v^.Miasto]:=w;
   v^.Nast:=L[w^.Miasto];  L[w^.Miasto]:=v
  end; {for i}
  close(f);
   {Zainicjalizowanie listy z bezpiecznym planem.}
  new(bPocz);  new(bOst);
  with bPocz^ do begin
   Poprz:=nil;  Nast:=bOst;
   Miasto:=1
  end;
  with bOst^ do begin
   Poprz:=bPocz;  Nast:=nil;
   Miasto:=L[1]^.Miasto
  end
 end; {Inicjalizacja}

 procedure UtworzBezpiecznyPlan;
  var
   Kolejny:ElPlanuWsk;
    {Wskaznik do kolejnego przetwarzanego miasta z listy zawierajacej
     bezpieczny plan.}
   Status :array[1..MaksN] of (NaPlanie,Odwiedzony,NieOdwiedzony);
    {Status miast.}
   i,m    :integer;
   KolSas :ElListySasWsk;
  procedure RozszerzPlan(Od:integer);
   {Od - miasto nie nalezace do listy zawierajacej bezpieczny plan,
    sasiadujace z miastem wskazywanym przez Kolejny.}
   var
    Rozszerzenie,Odwiedzone:array[1..MaksN] of 1..MaksN;
     {Rozszerzenie - tu wyznaczymy droge laczaca Od z miastem na liscie
                     zawirajacej bezpieczny plan, wystepujacym po Kolejny;
      Odwiedzone   - tu zapamietamy wszystkie wierzcholki spoza listy
                     bezpieczny plan odwiedzone podczs przeszukiwania grafu.}
    DlRoz,IleOd            :integer;
     {DlRoz - aktualna liczba elementow w tablicy Rozszerzenie;
      IleOd - aktualna liczba elementow w tablicy Odwiedzone.}
    KolejnyNaLiscie        :array[1..MaksN] of ElListySasWsk;
     {Tablica wykorzystywana podczas poszukiwania drogi;
      KolejnyNaLiscie[i] - wskaznik do pierwszego elementu z listy
      sasiadow miasta i, ktory nie byl jeszcze odwiedzony z i.}
    OstwRoz                :integer; {Ostatnie miasto na budowanej drodze.}
    u,v,w                  :ElPlanuWsk;
    i                      :integer;
  begin
    {Pierwszym miastem na poszukiwanej drodze jest Od.}
   Rozszerzenie[1]:=Od;  DlRoz:=1;
   Odwiedzone[1]:=Od;  IleOd:=1;
   Status[Od]:=Odwiedzony;
   KolejnyNaLiscie[Od]:=L[Od];
   OstwRoz:=Od;
   repeat
     {Sprawdzenie, czy mozna rozszerzyc droge o kolejnego sasiada
      ostaniego miasta na zbudowanej drodze.}
    if KolejnyNaLiscie[OstwRoz]=nil then begin
      {Przez miasto OstwRoz nie prowadzi zadna droga o poczatku w Od
       i koncu w miescie z listy zawirajacej bezpieczny plan,
       wystepujacym po miescie wskazywanym przez Kolejny.}
      {Usuwamy miasto OstwRoz z budowanej drogi i wracamy
       do poprzedzajacego je miasta na tej drodze.}
     DlRoz:=DlRoz-1;
     OstwRoz:=Rozszerzenie[DlRoz]
    end {if }
    else
     case Status[KolejnyNaLiscie[OstwRoz]^.Miasto] of
      NieOdwiedzony: {Rozszerzamy budowana droge o kolejne miasto.}
       begin
        DlRoz:=DlRoz+1;
        Rozszerzenie[DlRoz]:=KolejnyNaLiscie[OstwRoz]^.Miasto;
         {Przesuniecie wskaznika KolejnyNaLiscie do
          nastepnego miasta na liscie sasiadow miasta OstwRoz.}
        KolejnyNaLiscie[OstwRoz]:=KolejnyNaLiscie[OstwRoz]^.Nast;
        OstwRoz:=Rozszerzenie[DlRoz];
        KolejnyNaLiscie[OstwRoz]:=L[OstwRoz];
        IleOd:=IleOd+1;
        Odwiedzone[IleOd]:=OstwRoz;
        Status[OstwRoz]:=Odwiedzony
       end;
      Odwiedzony   :  {W tym miescie juz bylismy, przechodzimy do
                       nastepnego miasta na liscie sasiadow OstwRoz.}
       KolejnyNaLiscie[OstwRoz]:=KolejnyNaLiscie[OstwRoz]^.Nast;
      NaPlanie     :  {Doszlismy do miasta z listy zawirajacej bezpieczny plan.}
       if KolejnyNaLiscie[OstwRoz]^.Miasto<>Kolejny^.Miasto then
         {Zbudowalismy droge.}
        OstwRoz:=KolejnyNaLiscie[OstwRoz]^.Miasto
       else {Niestety dotarlismy do miasta wskazywanego przez Kolejny;
             przechodzimy do nastepnego miasta na liscie sasiadow OstwRoz.}
        KolejnyNaLiscie[OstwRoz]:=KolejnyNaLiscie[OstwRoz]^.Nast
     end {case Status[... }
   until Status[OstwRoz]=NaPlanie;
    {Umieszczenie miast ze znalezionej drogi na liscie zawirajacej
     bezpieczny plan po miescie wskazywanym przez Kolejny.}
   u:=Kolejny;  v:=Kolejny^.Nast;
   for i:=1 to DlRoz do begin
    new(w);  u^.Nast:=w;
    w^.Poprz:=u;  w^.Miasto:=Rozszerzenie[i];
    u:=w;  Status[w^.Miasto]:=NaPlanie
   end; {for }
   u^.Nast:=v;  v^.Poprz:=u;
    {Przywrocenie statusu NieOdwiedzony wszystkim miastom odwiedzanym
     w trakcie wyznaczania drogi, ktore nie znalazly sie na tej drodze.}
   for i:=1 to IleOd do
    if Status[Odwiedzone[i]]=Odwiedzony then
     Status[Odwiedzone[i]]:=NieOdwiedzony
  end; {RozszerzPlan}
 begin {Procedura UtworzBezpiecznyPlan}
   {Ustalenie poczatkowego statusu poszczegolnych miast.}
  for i:=2 to n do Status[i]:=NieOdwiedzony;
  Status[1]:=NaPlanie;  Status[bOst^.Miasto]:=NaPlanie;
   {Przejscie po liscie zawierajacej bezpieczny plan od bPocz do bKon.}
  Kolejny:=bPocz;
  repeat
   m:=Kolejny^.Miasto;
   KolSas:=L[m];
   while KolSas<>nil do begin
    if Status[KolSas^.Miasto]=NieOdwiedzony then
      {Znalezlismy sasiada, ktory nie wystepuje na liscie zawierajacej
       bezpieczny plan.}
     RozszerzPlan(KolSas^.Miasto);
    KolSas:=KolSas^.Nast
   end; {while }
   Kolejny:=Kolejny^.Nast
  until Kolejny=bOst
 end; {UtworzBezpiecznyPlan}

 procedure Wynik;
   {Wypisanie planu tras goncow.}
  var
   f:text;
   v:ElPlanuWsk;
 begin
  assign(f,'GON.OUT');  rewrite(f);
  write(f,1);
  v:=bPocz;
  repeat
   v:=v^.Nast;
   write(f,' ',v^.Miasto)
  until v=bOst;
  writeln(f);
  write(f,1);
  while v<>bPocz do begin
   write(f,' ',v^.Miasto);
   v:=v^.Poprz
  end;
  close(f)
 end; {Wynik}

begin {Program glowny}
 Inicjalizacja;
 UtworzBezpiecznyPlan;
 Wynik
end. {Goncy}

