{*************************************************************************}
{*                                                                       *}
{*                  III Olimpiada Informatyczna                          *}
{*                                                                       *}
{*   Rozwiazanie zadania: MOKRA ROBOTA                                   *}
{*   Plik:                MOK.PAS - program glowny                       *}
{*   Autor:               Marcin Engel i Piotr Chrzastowski-Wachtel      *}
{*************************************************************************}

program MokraRobota;
 uses
  Typy,InOut,Wstepne,Kolejka;
   {Teksty modulow sa umieszczone w plikach: TYPE.PAS, INOUT.PAS,
    WSTEPNE.PAS, KOLEJKA.PAS odpowiednio.}
 var
  IleNaczyn  :NumerNaczynia;
  sp,sk,s    :Stan;
  Krok       :longint;
  JestRozw   :boolean;
  WagaKoncowa:byte;

 function Osiagalna(Ile:NumerNaczynia; s,sk:Stan; Krok:longint):boolean;
  {Generuje stany osiagalne w jednym kroku z s i sprawdza, czy jest wsrod}
  {nich koncowy stan. Jesli tak to przyjmuje wartosc true.}
  {Wygenerowane stany, ktore jeszcze nie byly rozpatrywane, sa wstawiane }
  {do kolejki, o ile moga one jeszcze doprowadzic do stanu koncowego.}
  var
   i,j   :1..MaxNAczynie+1;
   Koniec:boolean;
   ns    :Stan;
 begin
  i:=1;  Koniec:=false;
  while not Koniec and (i<=Ile) do begin
   if not Puste(s,i) then begin
     {dla kazdego niepustego naczynia w zestawie s }
    Wylej(s,i,ns);
     {utworz stan ns wylewajac wode z i-tego naczynia zestawu s }
    Koniec:=Rowne(Ile,ns,sk);
    if not Koniec and AnalizaWTrakcie(Ile,ns,sk) then
      {jesli nie koncowy i sensowny }
     Wstaw(Ile,ns,Krok+1,WagaKoncowa)
      {to wstawiamy do kolejki }
   end; {if not Puste(s,i) }
   inc (i)
  end; {while }
  if not Koniec then begin {jesli nie bylo jeszcze koncowego }
   i:=1;
   while (i<=Ile) and not Koniec do begin
    j:=1;
    while (j<=Ile) and not Koniec do begin
     if (i<>j) and not Puste(s,i) and not Pelne(s,sp,j) then begin
       { dla kazdej pary roznych naczyn takich, ze
         i-te jest niepuste, a j-te niepelne }
      Przelej(s,sp,i,j,ns);
       { utworz nowy stan ns przelewajac wode z
         i-tego do j-tego naczynia zestawu s }
      Koniec:=Rowne(Ile,ns,sk);
       { jesli stan koncowy }
      if not Koniec and AnalizaWTrakcie(Ile,ns,sk) then
       { jesli nie koncowy i sensowny }
      Wstaw(Ile,ns,Krok+1,WagaKoncowa)    { to wstaw go do kolejki }
     end; {if }
     inc(j)
    end; {while }
    inc(i)
   end {while }
  end; {in not Koniec }
  Osiagalna:=Koniec
 end; {Osiagalna}

begin {Program glowny}
 CzytajDane(IleNaczyn,sp,sk);
  { wczytuje liczbe naczyn, sp i sk z pliku wejsciowego }
 if Rowne(IleNaczyn,sp,sk) then WypiszWynik(0)
 else begin
  if AnalizaWstepna(IleNaczyn,sp,sk) then begin
    { jesli wstepnie wychodzi, ze mozna osiagnac sk z sp }
   JestRozw:=false;
   Inicjuj(IleNaczyn,sp,WagaKoncowa);
    { wstaw do kolejki stan poczatkowy z liczba krokow 0 }
   while not KolejkaPusta and not JestRozw do begin
    Pobierz(IleNaczyn,s,Krok);
     { pobierz pierwszy stan z kolejki }
    JestRozw:=Osiagalna(IleNaczyn,s,sk,Krok);
     { sprawdz czy sk osiagalna z s w jednym kroku. }
     { Wstaw wszystkie osiagalne, ktore jeszcze nie
       byly rozpatrywane do kolejki }
    UsunZbedne
     { Usun juz nieistotne informacje }
   end; {while }
   if JestRozw then WypiszWynik(Krok+1)
   else WypiszWynik(-1)
  end {in AnalizaWstepna }
  else               { Wstepna analiza odrzucila istnienie rozwiazan }
   WypiszWynik(-1);
  Sprzataj
 end {Gdy stan sp jest rozny od stanu sk.}
end. {MokraRobota}

