{*************************************************************************}
{*                                                                       *}
{*                  III Olimpiada Informatyczna                          *}
{*                                                                       *}
{*   Rozwiazanie zadania: PERMUTACJE ANTYARYTMETYCZNE                    *}
{*   Plik:                PER.PAS                                        *}
{*   Autor:               Wojciech Guzicki                               *}
{*************************************************************************}

program PermutacjeAntyarytmetyczne;
 const
  MaxL=20; {Maksymalna dlugosc rozwiniecia dwojkowego: 2^20>10^6.}
 type
  Rozw=array[1..MaxL] of byte; {Rozwiniecia dwojkowe liczb.}

 procedure Wczytaj(var n:longint);
   {Procedura wczytuje liczbe n z pliku wejsciowego PER.IN.}
  var f:text;
 begin
  assign(f,'PER.IN');
  reset(f);
  read(f,n);
  close(f)
 end; {Wczytaj}

 function Potega(l:integer):longint;
   {Potega(l) = 2^l}
  var
   i:integer;
   p:longint;
 begin
  p:=1;
  for i:=1 to l do p:=2*p;
  Potega:=p
 end; {Potega}

 function Dlugosc(p:longint):integer;
   {Dlugosc(p) = dlugosc rozwiniecia dwojkowego liczby p.}
  var dl:integer;
 begin {Algorytm szkolny: sukcesywnie dzielimy przez 2.}
  dl:=0;
  while p>0 do begin
   dl:=dl+1;
   p:=p div 2
  end;
  Dlugosc:=dl
 end; {Dlugosc}

 function Horner(r:Rozw; l:integer):longint;
    {"Zwijamy" rozwiniecie r za pomoca algorytmu Hornera.}
    {Rozwiniecie jest zapisane w kolejnosci r[1], r[2], ..., r[l].}
  var
   i:integer;
   h:longint;
 begin
  h:=0;
  for i:=1 to l do h:=2*h+r[i];
  Horner:=h
 end; {Horner}

 procedure Rozwin(p:longint; l:integer; var r:Rozw);
   {Liczbe p rozwijamy w systemie dwojkowym, rozwiniecie ma l cyfr.}
   {Cyfry sa zapisywane w kolejnosci r[1], r[2], ..., r[l].}
  var i:integer;
 begin {Szkolny algorytm.}
  for i:=1 to l do begin
   r[i]:=p mod 2;
   p:=p div 2
  end
 end; {Rozwin}

 var
  f    :text;
  l    :integer;
  h,n,p:longint;
  r    :Rozw;
begin
 Wczytaj(n);
 l:=Dlugosc(n);
 assign(f,'PER.OUT');
 rewrite(f);
 for p:=0 to Potega(l)-1 do begin
  Rozwin(p,l,r);
  h:=Horner(r,l);
  if h<n then writeln(f,h)
 end; {for p }
 close(f)
end. {PermutacjeAntyarytmetyczne}
